package org.snap.jounin;

import java.util.*;

import org.planet.p2pcm.*;

import dermi.exception.*;
import dermi.annotation.*;

@DermiRemoteInterface
public interface Jounin extends ComponentInterface {
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public Participant getParticipant(String user) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void addParticipant(Participant part) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public boolean existsParticipant(String user) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void deleteParticipant(String user) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public Portal getPortal(String name) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void addPortal(Portal port) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void deletePortal(String name) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public boolean existsPortal(String name) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void loginParticipant(String name) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public ArrayList getLastVisitors() throws RemoteException;
}
