package org.snap.jounin;

import dermi.exception.*;
import org.planet.p2pcm.*;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class PServlet extends HttpServlet {	
	private static final long serialVersionUID = 2345734;
	
	private ServletContext ctx;
	//private Application jounin_app;
	//private DHTHandler dht;
	private Participant part;
	private Portal port;
	private Jounin jounin;
	
	public void init (ServletConfig config) throws ServletException {
		super.init (config);
		ctx = config.getServletContext();
		//jounin_app = (Application) ctx.getAttribute ("snapApp");
		//dht = jounin_app.getStorageContext();
		jounin = (Jounin) ctx.getAttribute("jounin_main_app");
		if(jounin == null) {
			JouninFactory fac;
			try {
				fac = (JouninFactory) ComponentUtil.getComponentFactory ("p2p://jounin-component.urv.net");
				jounin = (Jounin) fac.createInstance ("org.snap.jounin.Jounin");
			} catch (Exception e) {
				e.printStackTrace();
			}
			ctx.setAttribute("jounin_main_app", jounin);
		}
	}
	
	protected void processRequest(HttpServletRequest request, HttpServletResponse response) throws ServletException, java.io.IOException, RemoteException, ComponentNotRegisteredException, ComponentInitializationException, InterfaceNotFoundException {
		HttpSession session = request.getSession(true);
		String username = (String)session.getAttribute("participant");
		String portal_id = (String)session.getAttribute("portal");
		if(username==null || portal_id==null) return;
		
		part = jounin.getParticipant(username);
		port = jounin.getPortal(portal_id);
		
		String action = request.getParameter("action");
		if (action != null) {
			if (action.compareTo("position")==0) {
				String portlet = request.getParameter("portlet");
				String row = request.getParameter("row");
				String col = request.getParameter("col");
				if(portlet!=null && row!=null && col!=null) {
					ParticipantProfile pp = part.getPortletProfile(portlet, port.getName());
					pp.setCol(Integer.parseInt(col));
					pp.setRow(Integer.parseInt(row));
					System.out.println("Changed portlet position !!");
				}
			}
			else if (action.compareTo("state")==0) {
				String portlet = request.getParameter("portlet");
				String state = request.getParameter("state");
				if(portlet!=null && state!=null) {
					ParticipantProfile pp = part.getPortletProfile(portlet, port.getName());
					if(state.compareTo("close")==0)
						pp.setState(ParticipantProfile.PortletState.CLOSE);
					else if(state.compareTo("help")==0)
						pp.setState(ParticipantProfile.PortletState.HELP);
					else if(state.compareTo("view")==0)
						pp.setState(ParticipantProfile.PortletState.VIEW);
					else if(state.compareTo("edit")==0)
						pp.setState(ParticipantProfile.PortletState.EDIT);
					System.out.println("Changed portlet status !!");
				}
			}
			else if (action.compareTo("size")==0) {
				String portlet = request.getParameter("portlet");
				String height = request.getParameter("height");
				if(portlet!=null && height!=null) {
					ParticipantProfile pp = part.getPortletProfile(portlet, port.getName());
					pp.setHeight(Integer.parseInt(height));
					System.out.println("Changed portlet size !!");
				}
			}
		}
	}
	
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try {
			processRequest(request, response);
		} catch (ServletException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (ComponentNotRegisteredException e) {
			e.printStackTrace();
		} catch (ComponentInitializationException e) {
			e.printStackTrace();
		} catch (InterfaceNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try {
			processRequest(request, response);
		} catch (ServletException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (ComponentNotRegisteredException e) {
			e.printStackTrace();
		} catch (ComponentInitializationException e) {
			e.printStackTrace();
		} catch (InterfaceNotFoundException e) {
			e.printStackTrace();
		}
	}
} 
