package org.snap.jounin;

import java.util.*;

import org.planet.p2pcm.*;

import dermi.exception.*;
import dermi.annotation.*;

@DermiRemoteInterface
public interface Portal extends ComponentInterface {
	static public enum Rol {
		ADMIN, USER, NONE
	}
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public String getName() throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public String getDescription() throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void setDescription(String a) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void addParticipant(String name, Rol rol) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void delParticipant(String name) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public Collection getParticipants() throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public Rol getParticipantRol(String part) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void setParticipantRol(String part, Rol rol) throws RemoteException;
	
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public String getPortletUrl(String name) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public boolean hasPortlet(String name) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void addPortlet(String name, String url) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void delPortlet(String name) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public Collection getPortlets() throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void delete() throws RemoteException;
}
